<?php
/**
 * @ H2N Link Directory 1.0.0 admin.categories.php
 * @ Copyright (C) 2008 Harry Klein - joomla.neschke.eu
 * @
 * @ Link Directory 1.1 admin.categories.php
 * @ Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @ All rights reserved
 * @ Link Directory Component is Free Software
 * @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
 **/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

function showCategories( $section, $option ) {
	global $database, $mainframe, $mosConfig_list_limit;
	$limit 		= intval( $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit ) );
	$limitstart = intval( $mainframe->getUserStateFromRequest( "view{$section}limitstart", 'limitstart', 0 ) );
	$levellimit = intval( $mainframe->getUserStateFromRequest( "view{$option}limit", 'levellimit', 10 ) );

	$query = "SELECT  c.*, c.parent_id as parent, g.name AS groupname, u.name AS editor,"
	. "COUNT( DISTINCT s2.checked_out ) AS checked_out"
	. "\n FROM #__ldcats AS c"
	. "\n LEFT JOIN #__users AS u ON u.id = c.checked_out"
	. "\n LEFT JOIN #__groups AS g ON g.id = c.access"
	. "\n LEFT JOIN #__ldlinks AS s2 ON s2.catid = c.id AND s2.checked_out > 0"
	. "\n GROUP BY c.id"
	. "\n ORDER BY c.ordering, c.name";

	$database->setQuery( $query );
	$rows = $database->loadObjectList();

	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	// establish the hierarchy of the categories
	$children = array();
	// first pass - collect children
	foreach ($rows as $v) {
		$pt = $v->parent;
		$list = @$children[$pt] ? $children[$pt] : array();
		array_push($list, $v);
		$children[$pt] = $list;
	}
	// second pass - get an indent list of the items
	$list = mosTreeRecurse(0, '', array(), $children, max(0, $levellimit-1));

	$total = count($list);

	require_once(_LD_ABSOLUTE_PATH.'/administrator/includes/pageNavigation.php');
	$pageNav = new mosPageNav($total, $limitstart, $limit);

	$levellist = mosHTML::integerSelectList(1, 20, 1, 'levellimit', 'size="1" onchange="document.adminForm.submit();"', $levellimit);
	// slice out elements based on limits

	$list = array_slice($list, $pageNav->limitstart, $pageNav->limit);

	 
	Categories_html::show( $option, $pageNav, $list );
}

//bu fonksiyon tamamd?r ;)
function editCategory($uid) {
	global $database, $my;

	$row = new snrCats($database);
	// load the row from the db table
	$row->load($uid);
	// fail if checked out not by 'me'
	if ($row->checked_out && $row->checked_out <> $my->id) {
		mosRedirect('index2.php?option=com_linkdirectory&task=categories', 'The category ' . $row->title . ' is currently being edited by another administrator');
	}

	if ($uid) {
		// existing record
		$row->checkout($my->id);
		// code for Link Menu
	} else {
		// new record
		$row->published = 1;
	}
	// make order list
	$order = array();
	$database->setQuery("SELECT COUNT(*) FROM #__ldcats");
	$max = intval($database->loadResult()) + 1;

	for ($i = 1; $i < $max; $i++) {
		$order[] = mosHTML::makeOption($i);
	}
	// build the html select list for ordering
	$query = "SELECT ordering AS value, title AS text"
	. "\n FROM #__ldcats"
	. "\n ORDER BY ordering" ;
	 
	$lists['ordering'] = mosAdminMenus::SpecificOrdering($row, $uid, $query);
	// Imagelist
	$lists['image'] 			= mosAdminMenus::Images( 'image', $row->image );
	// build the html select list for the group access
	$lists['access'] 			= mosAdminMenus::Access( $row );
	// build the html radio buttons for published
	$lists['published'] 		= mosHTML::yesnoRadioList( 'published', 'class="inputbox"', $row->published );
	// build the html select list for paraent item
	$options = array();
	$options[] = mosHTML::makeOption('0', _LD_TOP );
	$lists['parent'] = categoryParentList($row->id, $row->parent_id, $options);
	$section = NULL;
	$redirect = NULL;
	Categories_html::edit($row, $section, $lists, $redirect);
}

function publishCategories( $categoryid=null, $cid=null, $publish=1 ) {
	global $database, $my;

	if (!is_array( $cid )) {
		$cid = array();
	}
	if ($categoryid) {
		$cid[] = $categoryid;
	}

	if (count( $cid ) < 1) {
		$action = $publish ? 'publish' : 'unpublish';
		echo "<script> alert('Select a category to $action'); window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );

	$query = "UPDATE #__ldcats"
	. "\n SET published = " . intval( $publish )
	. "\n WHERE id IN ( $cids )"
	. "\n AND ( checked_out = 0 OR ( checked_out = $my->id ) )"
	;
	$database->setQuery( $query );
	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (count( $cid ) == 1) {
		$row = new snrCats( $database );
		$row->checkin( $cid[0] );
	}

	mosRedirect( 'index2.php?option=com_linkdirectory&task=categories' );
}


function saveCategory( $task ) {
	global $database;

	$row = new snrCats( $database );
	if (!$row->bind( $_POST )) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	$row->title = addslashes( $row->title );
	$row->name	= addslashes( $row->name );
	if (!$row->check()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (!$row->store()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	$row->checkin();


	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	switch ( $task ) {

		case 'apply':
			$msg = _LD_CATCHANGESAVE;
			mosRedirect( 'index2.php?option=com_linkdirectory&task=editA&hidemainmenu=1&id='. $row->id, $msg );
			break;

		case 'save':
		default:
			$msg = _LD_CATSAVE;
			mosRedirect( 'index2.php?option=com_linkdirectory&task=categories', $msg );
			break;
	}
}

function removeCategories( $section, $cid ) {
	global $database;

	if (count( $cid ) < 1) {
		echo "<script> alert('Select a category to delete'); window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );

	$query = "SELECT c.id, c.name, COUNT( s.catid ) AS numcat"
	. "\n FROM #__ldcats AS c"
	. "\n LEFT JOIN #__ldlinks AS s ON s.catid = c.id"
	. "\n WHERE c.id IN ( $cids )"
	. "\n GROUP BY c.id"
	;
	$database->setQuery( $query );

	if (!($rows = $database->loadObjectList())) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
	}

	$err = array();
	$cid = array();
	foreach ($rows as $row) {
		if ($row->numcat == 0) {
			$cid[] = $row->id;
		} else {
			$err[] = $row->name;
		}
	}

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$query = "DELETE FROM #__ldcats"
		. "\n WHERE id IN ( $cids )"
		;
		$database->setQuery( $query );
		if (!$database->query()) {
			echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	if (count( $err )) {
		$cids = implode( "\', \'", $err );
		$msg = $cids .'-'. _LD_CATNOTDELETE;
		mosRedirect( 'index2.php?option=com_linkdirectory&task=categories&mosmsg='. $msg );
	}

	mosRedirect( 'index2.php?option=com_linkdirectory&task=categories' );
}

function orderCategory( $uid, $inc ) {
	global $database;

	$row = new snrCats( $database );
	$row->load( $uid );
	$row->move( $inc );

	mosRedirect( 'index2.php?option=com_linkdirectory&task=categories' );
}


function saveOrder( &$cid, $section ) {
	global $database;

	$total		= count( $cid );
	$order 		= mosGetParam( $_POST, 'order', array(0) );
	$row		= new snrCats( $database );
	$conditions = array();

	// update ordering values
	for( $i=0; $i < $total; $i++ ) {
		$row->load( $cid[$i] );
		if ($row->ordering != $order[$i]) {
			$row->ordering = $order[$i];
			if (!$row->store()) {
				echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
				exit();
			} // if
			// remember to updateOrder this group
			$condition = "section='$row->section'";
			$found = false;
			foreach ( $conditions as $cond )
			if ($cond[1]==$condition) {
				$found = true;
				break;
			} // if
			if (!$found) $conditions[] = array($row->id, $condition);
		} // if
	} // for

	// execute updateOrder for each group
	foreach ( $conditions as $cond ) {
		$row->load( $cond[0] );
		$row->updateOrder( $cond[1] );
	} // foreach

	$msg 	= _LD_ORDERSAVE;
	mosRedirect( 'index2.php?option=com_linkdirectory&task=categories', $msg );
} // saveOrder


function accessMenu( $uid, $access, $section ) {
	global $database;

	$row = new snrCats( $database );
	$row->load( $uid );
	$row->access = $access;

	if ( !$row->check() ) {
		return $row->getError();
	}
	if ( !$row->store() ) {
		return $row->getError();
	}

	mosRedirect( 'index2.php?option=com_linkdirectory&task=categories' );
}
?>
